%define ROOT /var/ftp
%define copy_cmd copy() { file="`ls --sort=time $1 |head -n 1`"; ln -f "$file" "$2" 2>/dev/null || cp -df "$file" "$2"; }

Summary: A fast, read-only, anonymous FTP server.
Name: anonftp
Version: 4.0
Release: 12
License: GPL
Group: System Environment/Daemons
Source: recompress.c
Prefix: %{ROOT}
BuildRoot: %{_tmppath}/%{name}-root
AutoReqProv: 0
Requires: ftpserver grep
Prereq: /usr/sbin/usermod, glibc, fileutils >= 4.0.36-3, gzip, cpio, tar >= 1.13.19-4, libtermcap, sh-utils, textutils

%description
Anonftp is a fast, read-only, anonymous FTP server. Anonymous FTP
access allows anyone to download files from an FTP server. Anonymous
FTP is a popular way of making files available via the Internet.

Install the anonftp package if you would like to enable anonymous
FTP downloads from your FTP server.

%prep
%setup -T -c
cp $RPM_SOURCE_DIR/recompress.c .

%build
%{__cc} $RPM_OPT_FLAGS -o recompress recompress.c

%install
[ "$RPM_BUILD_ROOT" != "/" ] && rm -rf $RPM_BUILD_ROOT
mkdir -p $RPM_BUILD_ROOT%{ROOT}
mkdir -p $RPM_BUILD_ROOT%{ROOT}/pub
mkdir -p $RPM_BUILD_ROOT%{ROOT}/etc
mkdir -p $RPM_BUILD_ROOT%{ROOT}/bin
mkdir -p $RPM_BUILD_ROOT%{ROOT}/lib
mkdir -p $RPM_BUILD_ROOT%{ROOT}/usr
ln -s ../bin $RPM_BUILD_ROOT%{ROOT}/usr
ln -s ../lib $RPM_BUILD_ROOT%{ROOT}/usr

cat > $RPM_BUILD_ROOT%{ROOT}/etc/passwd <<EOF
root:*:0:0:::
bin:*:1:1:::
operator:*:11:0:::
ftp:*:14:50:::
nobody:*:99:99:::
EOF

cat > $RPM_BUILD_ROOT%{ROOT}/etc/group <<EOF
root::0:
bin::1:
daemon::2:
sys::3:
adm::4:
ftp::50:
EOF

touch $RPM_BUILD_ROOT%{ROOT}/etc/ld.so.{conf,cache}

%clean
[ "$RPM_BUILD_ROOT" != "/" ] && rm -rf $RPM_BUILD_ROOT

%post
/usr/sbin/usermod -d %{ROOT} ftp 2>&1 > /dev/null || :

%triggerin -- glibc
%{copy_cmd}
# Kill off old versions
rm -f %{ROOT}/lib/ld-* %{ROOT}/lib/libc* %{ROOT}/lib/libnsl* %{ROOT}/lib/libnss_files* &>/dev/null || :
# Copy parts of glibc, needed by various programs in bin.
LIBCVER=`basename $(ls --sort=time /lib/libc-*.so |head -n 1) .so |cut -f2- -d-`
copy /lib/ld-${LIBCVER}.so %{ROOT}/lib
copy /lib/libc-${LIBCVER}.so %{ROOT}/lib
copy /lib/libnsl-${LIBCVER}.so %{ROOT}/lib
copy /lib/libnss_files-${LIBCVER}.so %{ROOT}/lib
md5sum %{ROOT}/lib/lib*-*.so %{ROOT}/lib/libtermcap.so.*.*.* 2>/dev/null >%{ROOT}/lib/libs.md5
chmod 0400 %{ROOT}/lib/libs.md5
# Use ldconfig to build symlinks and whatnot.
[ ! -e %{ROOT}/etc/ld.so.conf ] && touch %{ROOT}/etc/ld.so.conf
/sbin/ldconfig -r %{ROOT}

%triggerin -- fileutils
%{copy_cmd}
copy /bin/ls %{ROOT}/bin
md5sum `ls %{ROOT}/bin/* |grep -v bin.md5` >%{ROOT}/bin/bin.md5
chmod 0400 %{ROOT}/bin/bin.md5

%triggerin -- cpio
%{copy_cmd}
copy /bin/cpio %{ROOT}/bin
md5sum `ls %{ROOT}/bin/* |grep -v bin.md5` >%{ROOT}/bin/bin.md5
chmod 0400 %{ROOT}/bin/bin.md5

%triggerin -- tar
%{copy_cmd}
copy /bin/tar %{ROOT}/bin
md5sum `ls %{ROOT}/bin/* |grep -v bin.md5` >%{ROOT}/bin/bin.md5
chmod 0400 %{ROOT}/bin/bin.md5

%triggerin -- gzip
%{copy_cmd}
copy /bin/gzip %{ROOT}/bin
ln -sf gzip %{ROOT}/bin/zcat
md5sum `ls %{ROOT}/bin/* |grep -v bin.md5` >%{ROOT}/bin/bin.md5
chmod 0400 %{ROOT}/bin/bin.md5

%triggerin -- libtermcap
%{copy_cmd}
rm -f %{ROOT}/lib/libtermcap.so.*.*.* &>/dev/null || :
copy '/lib/libtermcap.so.*.*.*' %{ROOT}/lib
md5sum %{ROOT}/lib/lib*-*.so %{ROOT}/lib/libtermcap.so.*.*.* 2>/dev/null >%{ROOT}/lib/libs.md5
chmod 0400 %{ROOT}/lib/libs.md5
# Use ldconfig to build symlinks and whatnot.
[ ! -e %{ROOT}/etc/ld.so.conf ] && touch %{ROOT}/etc/ld.so.conf
/sbin/ldconfig -r %{ROOT}

%triggerin -- ncompress
%{copy_cmd}
copy /usr/bin/compress %{ROOT}/bin
md5sum `ls %{ROOT}/bin/* |grep -v bin.md5` >%{ROOT}/bin/bin.md5
chmod 0400 %{ROOT}/bin/bin.md5

%triggerpostun -- anonftp < 4.0
if [ "$2" != 1 ] ; then
	# The user has multiple glibc packages installed.  We can't read the
	# user's mind, so don't do anything.
	exit 0
fi
%{copy_cmd}
# Kill off old versions
rm -f %{ROOT}/lib/ld-* %{ROOT}/lib/libc* %{ROOT}/lib/libnsl* %{ROOT}/lib/libnss_files* &>/dev/null || :
# Copy parts of glibc, needed by various programs in bin.
LIBCVER=`basename /lib/libc-*.so .so | cut -f2- -d-`
copy /lib/ld-${LIBCVER}.so %{ROOT}/lib
copy /lib/libc-${LIBCVER}.so %{ROOT}/lib
copy /lib/libnsl-${LIBCVER}.so %{ROOT}/lib
copy /lib/libnss_files-${LIBCVER}.so %{ROOT}/lib
copy /bin/ls %{ROOT}/bin
copy /bin/cpio %{ROOT}/bin
copy /bin/tar %{ROOT}/bin
copy /bin/gzip %{ROOT}/bin
ln -sf gzip %{ROOT}/bin/zcat
copy /usr/bin/compress %{ROOT}/bin
rm -f %{ROOT}/lib/libtermcap.so.*.*.* &>/dev/null || :
copy '/lib/libtermcap.so.*.*.*' %{ROOT}/lib
# Use ldconfig to build symlinks and whatnot.
[ ! -e %{ROOT}/etc/ld.so.conf ] && touch %{ROOT}/etc/ld.so.conf
/sbin/ldconfig -r %{ROOT}
# Generate md5sums for verifyscript
md5sum %{ROOT}/lib/lib*-*.so %{ROOT}/lib/libtermcap.so.*.*.* 2>/dev/null >%{ROOT}/lib/libs.md5
chmod 0400 %{ROOT}/lib/libs.md5
md5sum `ls %{ROOT}/bin/* |grep -v bin.md5` >%{ROOT}/bin/bin.md5
chmod 0400 %{ROOT}/bin/bin.md5

%verifyscript
for i in %{ROOT}/bin/*; do
	[ "$i" = "%{ROOT}/bin/bin.md5" ] && continue
	sum=`md5sum $i`;
	if grep -q $i %{ROOT}/bin/bin.md5; then
		if ! grep -q $sum %{ROOT}/bin/bin.md5; then
			echo "5.......   $i" >&2
		fi
	else
		echo "5.......   $i" >&2
	fi
done
for i in %{ROOT}/lib/lib*-*.so %{ROOT}/lib/libtermcap.so.*.*.*; do
	[ "$i" = "%{ROOT}/lib/libs.md5" ] && continue
	sum=`md5sum $i`;
	if grep -q $i %{ROOT}/lib/libs.md5; then
		if ! grep -q $sum %{ROOT}/lib/libs.md5; then
			echo "5.......   $i" >&2
		fi
	else
		echo "5.......   $i" >&2
	fi
done


%preun
if [ $1 = 0 ]; then
	rm -f %{ROOT}/lib/* %{ROOT}/bin/*
fi

%files
%defattr(-,root,root)
%attr(0444,root,root) %config %{ROOT}/etc/passwd
%attr(0444,root,root) %config %{ROOT}/etc/group

%attr(0755,root,root) %dir %{ROOT}
%attr(0111,root,root) %dir %{ROOT}/bin
%attr(0111,root,root) %dir %{ROOT}/etc
%attr(0755,root,root) %dir %{ROOT}/lib
%attr(2755,root,ftp)  %dir %{ROOT}/pub

%ghost %attr(0644,root,root) %{ROOT}/etc/ld.so.conf
%ghost %attr(0644,root,root) %{ROOT}/etc/ld.so.cache

%changelog
* Fri Jun 21 2002 Tim Powers <timp@redhat.com>
- automated rebuild

* Thu May 23 2002 Tim Powers <timp@redhat.com>
- automated rebuild

* Wed Jan 09 2002 Tim Powers <timp@redhat.com>
- automated rebuild

* Wed Aug 22 2001 Bernhard Rosenkraenzer <bero@redhat.com> 4.0-9
- Read the glibc version from /lib, not /var/ftp/lib
  (broke fresh installs and glibc version updates, #52189, #51648)

* Mon Aug 20 2001 Bernhard Rosenkraenzer <bero@redhat.com> 4.0-8
- Fix #51648

* Tue Aug  7 2001 Bernhard Rosenkraenzer <bero@redhat.com> 4.0-7
- Revert Nalin's trigger change, it breaks fresh installs, isn't necessary
  and caused #50762
- Refine the copy() script to make sure it picks the current version

* Fri Jun  8 2001 Nalin Dahyabhai <nalin@redhat.com> 4.0-6
- Change the glibc trigger to be a %%triggerpostun, so we never have more than
  one version of glibc installed unless the user wants it that way.
- Don't strip the binary manually; let the build policy decide whether to.

* Wed Apr 25 2001 Bernhard Rosenkraenzer <bero@redhat.com> 4.0-5
- Fix a problem when updating libtermcap if several files match
  /lib/libtermcap.so.*.*.*. This should never happen, but apparently
  it occasionally does (#37465)

* Thu Mar 22 2001 Bernhard Rosenkraenzer <bero@redhat.com>
- Fix updating to newer anonftp-4.0-x packages (#32697)

* Mon Mar 19 2001 Bernhard Rosenkraenzer <bero@redhat.com>
- Fix updating from old systems

* Tue Mar 13 2001 Bernhard Rosenkraenzer <bero@redhat.com>
- Fix a typo in the ncompress trigger (we don't really want to copy
  anything to $RPM_BUILD_ROOT from a trigger. The typo didn't hurt because
  usually RPM_BUILD_ROOT isn't set in a trigger script).

* Tue Mar  6 2001 Bernhard Rosenkraenzer <bero@redhat.com>
- Replace the binaries with triggers so we profit from glibc (etc) updates

* Sat Jan 20 2001 Bernhard Rosenkraenzer <bero@redhat.com>
- Create /usr/bin->../bin, /usr/lib->../lib symlinks, so /usr/bin/compress
  can be invoked (so on-the-fly recompression works without changes
  for both anonymous and real users) (Bug #17537)
- rebuild with new glibc

* Tue Jan  9 2001 Bernhard Rosenkraenzer <bero@redhat.com>
- Rebuild with current system

* Thu Aug 17 2000 Nalin Dahyabhai <nalin@redhat.com>
- remove the libnss libs for glibc 2.0 -- none of the binaries need them

* Wed Aug 16 2000 Nalin Dahyabhai <nalin@redhat.com>
- add a %%post that runs "usermod -d %%{ROOT} ftp" to fix upgrades
- autodetect the libc version number (#16292)
- add librt, libnsl, libpthread, libtermcap for %{ROOT}/bin (#16292)

* Wed Jul 12 2000 Prospector <bugzilla@redhat.com>
- automatic rebuild

* Mon Jul  3 2000 Bernhard Rosenkraenzer <bero@redhat.com>
- adapt to current glibc
- fix build on ia64

* Tue Jun  6 2000 Bernhard Rosenkraenzer <bero@redhat.com>
- usr %{ROOT} instead of /home/ftp
- libc 2.1.90

* Fri Feb  4 2000 Bernhard Rosenkraenzer <bero@redhat.com>
- strip binaries and libraries
- rebuild to get latest libc

* Wed Feb 02 2000 Cristian Gafton <gafton@redhat.com>
- fix description and summary

* Tue Jan 11 2000 Bernhard Rosenkraenzer <bero@redhat.com>
- Add BuildPrereqs
- newer libc
- add recompress from BeroFTPD - it's useful for ftpconversions
- remove sh. Having a shell in the chroot ftp-structure is a security
  problem, not a feature.
- fix build with rpm 3.0.4

* Sun Mar 21 1999 Cristian Gafton <gafton@redhat.com> 
- auto rebuild in the new build environment (release 5)
- glibc version 2.1.1

* Tue Jan 12 1999 Cristian Gafton <gafton@redhat.com>
- add sparc

* Tue Jan 12 1999 Jeff Johnson <jbj@redhat.com>
- fix defattr typo (#784)
- newer libc

* Wed Jan 06 1999 Cristian Gafton <gafton@redhat.com>
- abuse the %attr settings instead of massive chown
- avoid cp-av because it breaks on symlinks (the wonders of lchown/chown
- rebuild for glibc 2.1

* Thu Sep 10 1998 Cristian Gafton <gafton@redhat.com>
- newer libc

* Thu Apr 30 1998 Cristian Gafton <gafton@redhat.com>
- updated for the newer glibc libs

* Thu Nov 06 1997 Donnie Barnes <djb@redhat.com>
- Built with glibc for the first time
- moved BuildRoot to /var/tmp
- mega-reworking of the spec file

* Mon Mar 03 1997 Erik Troan <ewt@redhat.com>
- Requires ftpserver virtual package now (which wu-ftpd provides).
